#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuildproxy4xi.py">
#<abstract4xi abstract = "provides function RebuildProxy4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'RebuildProxy4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import os
    import sys
    import weakref
    import threading
    import array
    import queue
    from traceback import format_exc
    import copyreg         
except:
    pass
     
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import RebuildProxy
except:
    print("rebuildproxy4xi.py *** failed in from multiprocessing.managers import RebuildProxy ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import get_current_process4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>
 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "RebuildProxy4Xi" usage = "
#   managers.py
#         __reduce__(self)
#             kwds = {}
#             if Popen.thread_is_spawning():
#                 kwds['authkey'] = self._authkey
# 
#             if getattr(self, '_isauto', False):
#                 kwds['exposed'] = self._exposed_
#                 return (RebuildProxy, (AutoProxy, self._token, self._serializer, kwds))
#             else:
#                 return (RebuildProxy, (type(self), self._token, self._serializer, kwds))
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def RebuildProxy4Xi(func, token, serializer, kwds):
    '''
    RebuildProxy4Xi function used for unpickling proxy objects.
    If possible the shared object is returned, or otherwise a proxy for it.
    
    '''
    class2print = "RebuildProxy4Xi"
    method2print = "RebuildProxy4Xi"
                
    # -----------------------------------------------------------------------------------------    
    # (Step 1/5)
    # -----------------------------------------------------------------------------------------        
   
    message2print = "{(Step 1/5a) started" + "; RebuildProxy4Xi-started: " + str(RebuildProxy4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/5b) passed" + "; func-passed-to-RebuildProxy4Xi: " + str(func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{(Step 1/5c) passed" + "; token-passed-to-RebuildProxy4Xi: " + str(token) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{(Step 1/5d) passed" + "; serializer-passed-to-RebuildProxy4Xi: " + str(serializer) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{(Step 1/5e) passed" + "; kwds-passed-to-RebuildProxy4Xi: " + str(kwds) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                           
                
    # -----------------------------------------------------------------------------------------    
    # (Step 2/5)
    # -----------------------------------------------------------------------------------------        
    
    message2print = "{(Step 2/5a) passing" + "; current-process-passing-to-getattr-by-RebuildProxy4Xi: " + str(get_current_process4xi()) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{(Step 2/5b) passing" + "; manager-server-passing-to-getattr-by-RebuildProxy4Xi: " + str('_manager_server') + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
    server2xi = getattr(get_current_process4xi(), '_manager_server', None)
    
    message2print = "{(Step 2/5c) set" + "; server2xi-set-by-RebuildProxy4Xi to: " + str(server2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                 
    
    # -----------------------------------------------------------------------------------------    
    # (Step 3/5)
    # -----------------------------------------------------------------------------------------        
    

    
    message2print = "{(Step 3/5) checking" + "; token-address-checking-by-RebuildProxy4Xi: " + str(token.address) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    if server2xi and server2xi.address == token.address:
    
        # -------------------------------------------------------------------------------------    
        # (Step 4/5)
        # -------------------------------------------------------------------------------------        
        
        message2print = "{(Step 4/5a) passing" + "; token-id-passing-to-server2xi-id-to-obj-by-RebuildProxy4Xi: " + str(token.id) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 4/5b) returning" + "; server2xi-object-returning-by-RebuildProxy4Xi: " + str(server2xi.id_to_obj[token.id][0]) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        

        return server2xi.id_to_obj[token.id][0]
    else:
    
        # -------------------------------------------------------------------------------------    
        # (Step 5/5)
        # -------------------------------------------------------------------------------------        
       
    
        incref = (
            kwds.pop('incref', True) and
            not getattr(get_current_process4xi(), '_inheriting', False)
            )
            
        message2print = "{(Step 5/5a) set" + "; incref-set-by-RebuildProxy4Xi to: " + str(incref)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  

        message2print = "{(Step 5/5b) passing" + "; token-passing-to-func-by-RebuildProxy4Xi: " + str(token) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        

        message2print = "{(Step 5/5c) passing" + "; serializer-passing-to-func-by-RebuildProxy4Xi: " + str(serializer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                                   

        message2print = "{(Step 5/5d) passing" + "; incref-passing-to-func-by-RebuildProxy4Xi: " + str(incref) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          


        message2print = "{(Step 5/5e) returning" + "; func-function-returning-by-RebuildProxy4Xi: " + str(func) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                              
        return func(token, serializer, incref=incref, **kwds)
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuildproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
